#!/usr/bin/env python

import os
import gtk
import gtk.glade
import gobject
import webbrowser

import functions
import clWidgets


def _(txt): return txt

class Pref():
    pass

class theme_selection(gtk.ComboBox):
    def __init__(self, value="None"):
        liststore = gtk.ListStore(gobject.TYPE_STRING)
        gtk.ComboBox.__init__(self, liststore)
        cell = gtk.CellRendererText()

        self.pack_start(cell, True)
        self.add_attribute(cell, 'text', 0)
        self.set_wrap_width(2)

        self.insert_text(0, "None")
        self.insert_text(1, value)
        self.set_active(1)

        counter = 1
        themes = functions.sorteddirlist()
        for theme in themes:
            counter += 1
            self.insert_text(counter, theme)
        self.show()

class DefaultPrefs():
    def __init__(self, pyjama=None):
        self.pyjama = pyjama

        #
        # Pyjama
        #
        self.pyjama = Pref()
        self.pyjama.vbox = gtk.VBox()
        self.pyjama.vbox.show()

        # Similar Albums
        hbox = gtk.HBox()
        hbox.show()
        l = gtk.Label("Number of similar Albums to\nshow on album pages")
        l.show()
        hbox.pack_start(l, False, False, 15)
        self.pyjama.spin_similar_albums = gtk.SpinButton()
        self.pyjama.spin_similar_albums.set_increments(1, 10)
        self.pyjama.spin_similar_albums.set_range(0, 15)
        self.pyjama.spin_similar_albums.set_value(5)
        self.pyjama.spin_similar_albums.show()
        hbox.pack_end(self.pyjama.spin_similar_albums, False, False, 30)
        self.pyjama.vbox.pack_start(hbox, False, False, 10)

        sep = gtk.HSeparator()
        sep.show()
        self.pyjama.vbox.pack_start(sep, False, False, 10)

        #Theme
        hbox = gtk.HBox()
        hbox.show()
        l = gtk.Label("Select a theme")
        l.show()
        hbox.pack_start(l, False, False, 15)
        self.pyjama.theme = theme_selection()# pass current theme here!
        self.pyjama.theme.show()
        hbox.pack_end(self.pyjama.theme, False, False, 30)
        self.pyjama.vbox.pack_start(hbox, False, False, 10)

        # Show toolbar text
        hbox = gtk.HBox()
        hbox.show()
        l = gtk.Label("Show toolbar text")
        l.show()
        hbox.pack_start(l, False, False, 15)
        self.pyjama.check_show_toolbar_text = gtk.CheckButton()
        self.pyjama.check_show_toolbar_text.show()
        hbox.pack_end(self.pyjama.check_show_toolbar_text, False, False, 30)
        self.pyjama.vbox.pack_start(hbox, False, False, 10)
        # Show entry in taskbar
        hbox = gtk.HBox()
        hbox.show()
        l = gtk.Label("Show pyjama in taskbar")
        l.show()
        hbox.pack_start(l, False, False, 15)
        self.pyjama.check_show_taskbar = gtk.CheckButton()
        self.pyjama.check_show_taskbar.show()
        hbox.pack_end(self.pyjama.check_show_taskbar, False, False, 30)
        self.pyjama.vbox.pack_start(hbox, False, False, 10)
        # Cover size
        hbox = gtk.HBox()
        hbox.show()
        l = gtk.Label("Cover size in notifications")
        l.show()
        hbox.pack_start(l, False, False, 15)
        self.pyjama.spin_notification_size = gtk.SpinButton()
        self.pyjama.spin_notification_size.set_increments(1, 10)
        self.pyjama.spin_notification_size.set_range(0, 400)
        self.pyjama.spin_notification_size.set_value(75)
        self.pyjama.spin_notification_size.show()
        hbox.pack_end(self.pyjama.spin_notification_size, False, False, 30)
        self.pyjama.vbox.pack_start(hbox, False, False, 10)
        # Notification Delay
        hbox = gtk.HBox()
        hbox.show()
        l = gtk.Label("How long should notifications been shown?\nValue in ms")
        l.show()
        hbox.pack_start(l, False, False, 15)
        self.pyjama.spin_notification_delay = gtk.SpinButton()
        self.pyjama.spin_notification_delay.set_increments(1, 100)
        self.pyjama.spin_notification_delay.set_range(0, 30000)
        self.pyjama.spin_notification_delay.set_value(5000)
        self.pyjama.spin_notification_delay.show()
        hbox.pack_end(self.pyjama.spin_notification_delay, False, False, 30)
        self.pyjama.vbox.pack_start(hbox, False, False, 10)

        #
        # Jamendo
        #
        self.jamendo = Pref()
        self.jamendo.vbox = gtk.VBox()
        self.jamendo.vbox.show()
        hbox = gtk.HBox()
        hbox.show()
        l = gtk.Label()
        l.set_markup("How many <b>days</b> should queries been stores\nthat <b>will change from time to time</b>.")
        l.show()
        hbox.pack_start(l, False, False, 15)
        self.jamendo.spin_caching_time_short = gtk.SpinButton()
        self.jamendo.spin_caching_time_short.set_increments(1, 100)
        self.jamendo.spin_caching_time_short.set_range(1, 365)
        self.jamendo.spin_caching_time_short.set_value(2)
        self.jamendo.spin_caching_time_short.show()
        hbox.pack_end(self.jamendo.spin_caching_time_short, False, False, 30)
        self.jamendo.vbox.pack_start(hbox, False, False, 10)

        hbox = gtk.HBox()
        hbox.show()
        l = gtk.Label()
        l.set_markup("How many <b>days</b> should queries been stores\nthat <b>won't change</b> probably.")
        l.show()
        hbox.pack_start(l, False, False, 15)
        self.jamendo.spin_caching_time_long = gtk.SpinButton()
        self.jamendo.spin_caching_time_long.set_increments(1, 100)
        self.jamendo.spin_caching_time_long.set_range(1, 365)
        self.jamendo.spin_caching_time_long.set_value(60)
        self.jamendo.spin_caching_time_long.show()
        hbox.pack_end(self.jamendo.spin_caching_time_long, False, False, 30)
        self.jamendo.vbox.pack_start(hbox, False, False, 10)

        hbox = gtk.HBox()
        hbox.show()
        l = gtk.Label()
        l.set_markup("<b>Streaming</b> format\nOGG has a better quality, MP3 supports seeking.")
        l.show() 
        vbox = gtk.VBox()
        vbox.show()
        hbox.pack_start(l, False, False, 15)
        self.jamendo.rbutton_format_stream_mp3 = gtk.RadioButton(None, "MP3")
        self.jamendo.rbutton_format_stream_mp3.show()
        vbox.pack_start(self.jamendo.rbutton_format_stream_mp3, False, False, 10)
        self.jamendo.rbutton_format_stream_ogg = gtk.RadioButton(self.jamendo.rbutton_format_stream_mp3, "OGG")
        self.jamendo.rbutton_format_stream_ogg.show()
        vbox.pack_end(self.jamendo.rbutton_format_stream_ogg, False, False, 10)
        hbox.pack_end(vbox, False, False, 30 )
        self.jamendo.vbox.pack_start(hbox, False, False, 10)
        
        hbox = gtk.HBox()
        hbox.show()
        l = gtk.Label()
        l.set_markup("<b>Download</b> format\nWhich format should be downloaded?")
        l.show()
        vbox = gtk.VBox()
        vbox.show()
        hbox.pack_start(l, False, False, 15)
        self.jamendo.rbutton_format_torrent_mp3 = gtk.RadioButton(None, "MP3")
        self.jamendo.rbutton_format_torrent_mp3.show()
        vbox.pack_start(self.jamendo.rbutton_format_torrent_mp3, False, False, 10)
        self.jamendo.rbutton_format_torrent_ogg = gtk.RadioButton(self.jamendo.rbutton_format_torrent_mp3, "OGG")
        self.jamendo.rbutton_format_torrent_ogg.show()
        vbox.pack_end(self.jamendo.rbutton_format_torrent_ogg, False, False, 10)
        hbox.pack_end(vbox, False, False, 30 )
        self.jamendo.vbox.pack_start(hbox, False, False, 10)

        #
        # Sound
        #
        self.sound = Pref()
        self.sound.vbox = gtk.VBox()
        self.sound.vbox.show()
        hbox = gtk.HBox()
        hbox.show()
        l = gtk.Label("Volume on startup")
        l.show()
        hbox.pack_start(l, False, False, 15)
        self.sound.spin_default_volume = gtk.SpinButton()
        self.sound.spin_default_volume.set_increments(1, 10)
        self.sound.spin_default_volume.set_range(0, 250)
        self.sound.spin_default_volume.set_value(75)
        self.sound.spin_default_volume.show()
        hbox.pack_end(self.sound.spin_default_volume, False, False, 30)
        self.sound.vbox.pack_start(hbox, False, False, 10)

        hbox = gtk.HBox()
        hbox.show()
        l = gtk.Label("Max Volume")
        l.show()
        hbox.pack_start(l, False, False, 15)
        self.sound.spin_max_volume = gtk.SpinButton()
        self.sound.spin_max_volume.set_increments(1, 10)
        self.sound.spin_max_volume.set_range(0, 250)
        self.sound.spin_max_volume.set_value(150)
        self.sound.spin_max_volume.show()
        hbox.pack_end(self.sound.spin_max_volume, False, False, 30)
        self.sound.vbox.pack_start(hbox, False, False, 10)


        #
        # Performance
        #
        self.perf = Pref()
        self.perf.vbox = gtk.VBox()
        self.perf.vbox.show()
        img = gtk.Image()
        img.show()
        img.set_from_stock(gtk.STOCK_DIALOG_WARNING, gtk.ICON_SIZE_DIALOG)
        self.perf.vbox.pack_start(img, False, False, 10)
        txt = gtk.Label()
        txt.show()
        txt.set_markup("Only advanced user should set performance \
        reladed preferences. For this reason I decided not to let \
        someone set those settings via this dialog. \
        Please edit <b>pyjama.cfg</b> in order to set \
        <i>history size</i>, <i>search limitis</i> or <i>thread related</i> settings.".replace(8*" ", "\n"))
        self.perf.vbox.pack_start(txt, False, False, 10)


        #
        # Plugins
        #
        self.plugin_vbox = gtk.VBox()
        self.plugin_vbox.show()
        img = gtk.Image()
        img.set_from_file(os.path.join(functions.install_dir(), "images", "plugin.png"))
        img.show()
        self.plugin_vbox.pack_start(img, False, True,10)
        l = gtk.Label(_("Please choose one of the plugins below in order to configure it."))
        l.show()
        self.plugin_vbox.pack_start(l, False, True,10)

        # Documentation button
        url = "http://xn--ngel-5qa.de/pyjama/html"
        hbox = gtk.HBox()
        hbox.show()
        l = gtk.Label(_("Learn more about\npyjama's plugin interface:"))
        l.show()
        hbox.pack_start(l)
        l = clWidgets.MyLinkButton(url, _("Pyjama's Documentation"))
        l.set_tooltip_text(url)
        l.connect("clicked", self.cb_visit_documentation)
        l.show()
        hbox.pack_start(l)
        self.plugin_vbox.pack_end(hbox, False, True, 20)

    def pyjama_save_preferences(self):
        print "Saves pyjama"

    def sound_save_preferences(self):
        print "Saves sound"

    def perf_save_preferences(self):
        print "Saves pref"

    def jamendo_save_preferences(self):
        print "Saves jamendo"

    def plugin_save_preferences(self):
        print "Saves plugins"

    #
    # Callbacks
    #
    def cb_visit_documentation(self, widget):
        webbrowser.open_new_tab(widget.uri)


PLUGIN_STRING = _("Plugins")

class Preferences():
    def __init__(self, pyjama=None):
        # Lists containing the plugins and the main modules
        self.plugins = []   # Preferences pages for plugins
        self.modules = []   # Some essential preferences pages
#        self.loaded_containers = {}
        self.currently_shown_box_name = None

        default = DefaultPrefs(pyjama)
        self.start_page = default.pyjama.vbox
        self.register_module("Pyjama", default.pyjama.vbox, default.pyjama_save_preferences)
        self.register_module("Sound", default.sound.vbox, default.sound_save_preferences)
        self.register_module("Jamendo", default.jamendo.vbox, default.jamendo_save_preferences)
        self.register_module("Performance", default.perf.vbox, default.perf_save_preferences)


        self.register_module(PLUGIN_STRING, default.plugin_vbox, default.plugin_save_preferences)

    ## Prepare the dialog by loading
    # the widgets from a glade file
    def __init_widgets(self):
        # Get the widgets from preferences.glade and
        # do some usefull stuff with them
        xml = gtk.glade.XML(os.path.join(functions.install_dir(), "preferences.glade"))
        self.dialog = xml.get_widget('dialog1')
        pixbuf = gtk.gdk.pixbuf_new_from_file(os.path.join(functions.install_dir(), "images", "pyjama.png"))
        self.dialog.set_icon(pixbuf)
        self.dialog.set_default_size(640,480)

        self.viewport = xml.get_widget('viewport1')
        sw = xml.get_widget('scrolledwindow1')
        self.treeview = xml.get_widget('treeview1')

        #TREEVIEW
        self.model = gtk.TreeStore(gobject.TYPE_STRING)
        self.treeview.set_model(self.model)
        renderer = gtk.CellRendererText()
        column = gtk.TreeViewColumn("Module", renderer, markup=0)
        self.treeview.append_column(column)

        self.treeview.connect("button-press-event", self.cb_treeview_button_press)
        self.treeview.connect("row-activated", self.cb_treeview_row_activated)

    ## Shows the preferences dialog
    def show_preferences(self):
        self.__init_widgets()

        ## Default Preferences
        for module in self.modules:
            if module['name'] != PLUGIN_STRING:
                self.model.append(None, (module['name'], ))

        ## Plugin Preferences
        TreeIterPlugins = self.model.append(None,(PLUGIN_STRING,))
        for pref in self.plugins:
            self.model.append(TreeIterPlugins, (pref['name'], ))

        self.treeview.expand_all()

        self.show_box(self.start_page, "Pyjama")

        ret = self.dialog.run()
        self.dialog.destroy()

#        self.loaded_containers = {}
        self.currently_shown_box_name = None

        if ret > 0:
            for module in self.modules:
                module["callback"]()
            for plugin in self.plugins:
                plugin["callback"]()


    ## Register a preferences page
    # use this for your plugins
    # @param self The Object Pointer
    # @param name Name to show (your plugin's name)
    # @param container A gtk.Container to show as you preferences page
    # @param cb A function to call when the preferences are saves
    def register_pref(self, name, container, cb):
        if not isinstance(container, gtk.Container):
            raise Exception, "The container you add must be a subclass " \
            "of gtk.Container - Try gtk.VBox() for example."
            return -1
        self.plugins.append({"name":name, "container":container, "callback":cb})

    ## Register a preferences page for builtin preferences
    # Use register_pref() instead.
    # use this for your plugins
    # @param self The Object Pointer
    # @param name Name to show (your plugin's name)
    # @param container A gtk.Container to show as you preferences page
    # @param cb A function to call when the preferences are saves
    def register_module(self, name, container, cb):
        if not isinstance(container, gtk.Container):
            raise Exception, "The container you add must be a subclass " \
            "of gtk.Container - Try gtk.VBox() for example."
            return -1
        self.modules.append({"name":name, "container":container, "callback":cb})

    ## Compute which item belongs to a certain path
    # and shows it
    # Internal methode
    # @param widget Container to show
    # @param path Path that has been selected
    def __show_items_pref(self, widget, path):
        if path:
            iter = widget.get_model().get_iter(path)
        else:
            return

        title = widget.get_model().get_value(iter, 0)
#        if title == PLUGIN_STRING:
#            self.show_box(module['container'])
#            return
        for module in self.modules:
            if module['name'] == title:
                self.show_box(module['container'], title)
                return
        for pref in self.plugins:
            if pref['name'] == title:
                self.show_box(pref['container'], title)
                return

    ## Show a certain Container
    # as a preferences page
    def show_box(self, box, name):
        if name == self.currently_shown_box_name: 
            print "Nothing changed"
            return
        ch = self.viewport.get_child()
        if ch:
            self.viewport.remove(ch)
        self.viewport.add(box)

#        ch = self.viewport.get_child()
#        if ch:
#            self.loaded_containers[self.currently_shown_box_name] = ch
#            self.viewport.remove(ch)
#        if name in self.loaded_containers:
#            self.viewport.add(self.loaded_containers[name])
#            print "old"
#        else:
#            self.viewport.add(box)
#            print "new"
#        self.currently_shown_box_name = name


    #
    # Callbacks
    #
    def cb_treeview_row_activated(self, treeview, path, view_column):
        self.__show_items_pref(treeview, path)

    def cb_treeview_button_press(self, widget, event):
        path = widget.get_path_at_pos(int(event.x), int(event.y))
        if path is not None:
            self.__show_items_pref(widget, path[0])



p = Preferences()
class plugin_pref():
    def __init__(self):
        self.vbox = gtk.VBox()
        l = gtk.Label("Dies ist ein Plugin-test")
        l.show()
        self.vbox.pack_start(l)
        self.vbox.show()

    def save_preferences(self):
        print "Hallo"
ppref = plugin_pref()
p.register_pref("Plugin1", ppref.vbox, ppref.save_preferences)

p.show_preferences()
